using System.Collections;
using System.Collections.Generic;

public class ItemTemplate {
  public string baseItemReference;
  public string uniqueName;
  public string displayName;
  public int uniqueIndex;
  public string description;
  public int maxUses;
  public EquipSlotType equipSlotType;
  public CraftingCategory craftingCategory;
  public string subCategory;
  public int subCategoryOrder;
  public Dictionary<string, int> recipe;
  public Dictionary<string, float> modifiers;
  public string spriteName;

  public ItemTemplate(string baseItemReference, string uniqueName, string displayName, int uniqueIndex, string description, int maxUses, EquipSlotType equipSlotType, CraftingCategory craftingCategory, string subCategory, int subCategoryOrder, Dictionary<string, int> recipe, Dictionary<string, float> modifiers, string spriteName = null) {
    this.baseItemReference = baseItemReference;
    this.uniqueName = uniqueName;
    this.displayName = displayName;
    this.uniqueIndex = uniqueIndex;
    this.description = description;
    this.maxUses = maxUses;
    this.equipSlotType = equipSlotType;
    this.craftingCategory = craftingCategory;
    this.subCategory = subCategory;
    this.subCategoryOrder = subCategoryOrder;
    this.recipe = recipe;
    this.modifiers = modifiers;
    this.spriteName = spriteName;
  }
}

public static class AugmentedEquipmentItems {
  public static Dictionary<string, ItemTemplate> AllAugmentedEquipmentItems = new Dictionary<string, ItemTemplate> {
    ["Hook_Titanium"] = new ItemTemplate(
      "Hook_Plastic",
      "Hook_Titanium",
      "Titanium Hook",
      16600,
      "An improved hook using titanium. The heavier weight makes it harder to throw but much more durable and better at pulling items out of the ground.",
      500,
      EquipSlotType.None,
      CraftingCategory.Tools,
      "Hooks",
      2,
      new Dictionary<string, int> { ["TitaniumIngot"] = 6, ["Bolt"] = 2, ["Scrap"] = 10, ["Rope"] = 4 },
      new Dictionary<string, float> {
        ["gatherTime"] = 0.5f
      }
    ),
    ["Titanium_Shovel"] = new ItemTemplate(
      "Shovel",
      "Titanium_Shovel",
      "Titanium Shovel",
      16601,
      "An improved shovel made out of titanium. It's more durable while being faster to handle.",
      120,
      EquipSlotType.None,
      CraftingCategory.Tools,
      "",
      1,
      new Dictionary<string, int> { ["TitaniumIngot"] = 4, ["Bolt"] = 4, ["Scrap"] = 15, ["Plank"] = 20 },
      new Dictionary<string, float> {
        ["digSpeedModifier"] = 0.5f
      }
    )
  };

  public static ItemTemplate Get(string uniqueName) {
    return AllAugmentedEquipmentItems[uniqueName];
  }
}